<?php
/**
 * IMPORTANT NOTE
 * The code of this system is closed and a private proprietary of Flex Solutions.
 * A written authorization/license from Flex Solutions is required before using or modifying this code.
 * Email: sales@flexsolution.biz, Phone: +962795342585, Website: http://www.flexsolutions.biz
 */
 
/**
 * This is the model class for table "v_asset".
 *
 * The followings are the available columns in table 'v_asset':
 * @property integer $id
 * @property integer $invoice_id
 * @property integer $type_of_asset_id
 * @property string $serial_number
 * @property string $asset_number
 * @property string $part_number
 * @property string $description
 * @property string $asset_status
 * @property string $plate_number
 * @property string $chassis_number
 * @property string $radioactive_license_number
 * @property integer $segment_id
 * @property string $po_number
 * @property integer $created_by
 * @property string $created_date
 * @property integer $last_edited_by
 * @property string $last_edited_date
 * @property integer $tid_id
 * @property string $tid_no
 * @property string $invoice_number
 * @property string $segment_name
 * @property string $po_segment_code
 * @property string $type_of_asset_name
 * @property string $vehicle_book_expiry_date
 * @property string $vehicle_book_status
 * @property integer $vehicle_book_expired_days
 * @property string $radioactive_license_expiry_date
 * @property double $fine
 * @property string $radioactive_license_status
 * @property integer $radioactive_license_expired_days
 * @property integer $asset_status_last_edited_by
 * @property string $asset_status_last_edited_date
 */
class VAsset extends TidansActiveRecord {

    /**
     * @return Integer the id of tid that the asset belong to
     */
    public $status;
    /**
     * @return Date the expiry date of radio active type
     */
    public $expiry_date;

    /**
     * @return string the associated database table name
     */
    public function tableName() {
	return 'v_asset';
    }

    /**
     * @return array validation rules for model attributes.
     */
    public function rules() {
	// NOTE: you should only define rules for those attributes that
	// will receive user inputs.
	return array(
	    array('invoice_id, type_of_asset_id, serial_number, asset_number, part_number, asset_status, segment_id, po_number, tid_no, invoice_number, segment_name, type_of_asset_name', 'required'),
	    array('id, invoice_id, type_of_asset_id, segment_id, created_by, last_edited_by, tid_id, vehicle_book_expired_days, radioactive_license_expired_days, asset_status_last_edited_by', 'numerical', 'integerOnly' => true),
	    array('fine', 'numerical'),
	    array('serial_number, asset_number, part_number, chassis_number', 'length', 'max' => 40),
	    array('description', 'length', 'max' => 200),
	    array('asset_status, plate_number, radioactive_license_number, po_segment_code', 'length', 'max' => 10),
	    array('po_number', 'length', 'max' => 15),
	    array('tid_no, invoice_number', 'length', 'max' => 20),
	    array('segment_name, type_of_asset_name', 'length', 'max' => 150),
	    array('vehicle_book_status, radioactive_license_status', 'length', 'max' => 7),
	    array('created_date, last_edited_date, vehicle_book_expiry_date, radioactive_license_expiry_date, asset_status_last_edited_date', 'safe'),
	    // The following rule is used by search().
	    // @todo Please remove those attributes that should not be searched.
	    array('expiry_days,grace_period,status,expiry_date,id, invoice_id, type_of_asset_id, serial_number, asset_number, part_number, description, asset_status, plate_number, chassis_number, radioactive_license_number, segment_id, po_number, created_by, created_date, last_edited_by, last_edited_date, tid_id, tid_no, invoice_number, segment_name, po_segment_code, type_of_asset_name, vehicle_book_expiry_date, vehicle_book_status, vehicle_book_expired_days, radioactive_license_expiry_date, fine, radioactive_license_status, radioactive_license_expired_days, asset_status_last_edited_by, asset_status_last_edited_date', 'safe', 'on' => 'search'),
	);
    }

    /**
     * @return array relational rules.
     */
    public function relations() {
	// NOTE: you may need to adjust the relation name and the related
	// class name for the relations automatically generated below.
	return array(
	);
    }

    /**
     * @return array customized attribute labels (name=>label)
     */
    public function attributeLabels() {
	return array(
	    'tid_id' => Yii::t('default', 'TID No'),
	    'invoice_id' => Yii::t('default', 'Invoice'),
	    'type_of_asset_id' => Yii::t('default', 'Type of Asset'),
	    'serial_number' => Yii::t('default', 'Serial Number'),
	    'asset_number' => Yii::t('default', 'Asset Number'),
	    'part_number' => Yii::t('default', 'Part Number'),
	    'description' => Yii::t('default', 'Description'),
	    'asset_status' => Yii::t('default', 'Asset Status'),
	    'plate_number' => Yii::t('default', 'Plate Number'),
	    'chassis_number' => Yii::t('default', 'Chassis Number'),
	    'radioactive_license_number' => Yii::t('default', 'Radioactive License Number'),
	    'segment_id' => Yii::t('default', 'Segment'),
	    'po_number' => Yii::t('default', 'PO Number'),
	    'tid_id' => Yii::t('default', 'TID'),
	    'tid_no' => Yii::t('default', 'TID No'),
	    'invoice_number' => Yii::t('default', 'Invoice Number'),
	    'segment_name' => Yii::t('default', 'Segment'),
	    'po_segment_code' => Yii::t('default', 'PO Segment Code'),
	    'type_of_asset_name' => Yii::t('default', 'Type of Asset'),
	    'vehicle_book_expiry_date' => Yii::t('default', 'Vehicle Book Expiry Date'),
	    'radioactive_license_expiry_date' => Yii::t('default', 'Radioactive License Expiry Date'),
	    'vehicle_book_status' => Yii::t('default', 'Vehicle Book Status'),
	    'vehicle_book_expired_days' => Yii::t('default', 'Vehicle Book Expired Days'),
	    'fine' => Yii::t('default', 'Fine'),
	    'radioactive_license_status' => Yii::t('default', 'Radioactive License Status'),
	    'radioactive_license_expired_days' => Yii::t('default', 'Radioactive License Expired Days'),
	    'asset_status_last_edited_by' => Yii::t('default', 'Asset Status Last Edited By'),
	    'asset_status_last_edited_date' => Yii::t('default', 'Asset Status Last Edited Date'),
	    'last_edited_by' => Yii::t('default', 'Asset Updated By'),
	    'grace_period' => 'Days to Expire',
	    'expiry_days' => Yii::t('default', 'Days Count'),
	    'username' => Yii::t('default', 'Last Updated By'),
	);
    }

    /**
     * Retrieves a list of models based on the current search/filter conditions.
     *
     * Typical usecase:
     * - Initialize the model fields with values from filter form.
     * - Execute this method to get CActiveDataProvider instance which will filter
     * models according to data in model fields.
     * - Pass data provider to CGridView, CListView or any similar widget.
     *
     * @return CActiveDataProvider the data provider that can return the models
     * based on the search/filter conditions.
     */
    public function search($invoice_id = null, $type_of_asset= null, $segment= null, $status= null, $date= null) {
	// @todo Please modify the following code to remove attributes that should not be searched.

	$criteria = $this->ModelCriteria($invoice_id, $type_of_asset, $segment, $status, $date);


	$pageSize = $this->yiiparam('pageSize');
	return new CActiveDataProvider($this, array(
	    'pagination' => array('pageSize' => $pageSize,),
	    'criteria' => $criteria,
	));
    }

    /**
     * Get the query used to get the current model information to be used in export to excel action
     * @return CDbCriteria the criteria used to get the current model information
     */
    public function ModelCriteria($invoice_id = null, $type_of_asset= null, $segment= null, $status= null, $date= null) { // @todo Please modify the following code to remove attributes that should not be searched.
	$criteria = new CDbCriteria;

	//$criteria->compare('id',$this->id);


	$criteria->compare('type_of_asset_id', $this->type_of_asset_id);
	$criteria->compare('serial_number', $this->serial_number, true);
	$criteria->compare('asset_number', $this->asset_number, true);
	$criteria->compare('part_number', $this->part_number, true);
	$criteria->compare('description', $this->description, true);
	$criteria->compare('asset_status', $this->asset_status, true);
	$criteria->compare('plate_number', $this->plate_number, true);
	$criteria->compare('chassis_number', $this->chassis_number, true);
	$criteria->compare('radioactive_license_number', $this->radioactive_license_number, true);
	$criteria->compare('segment_id', $this->segment_id);
	$criteria->compare('po_number', $this->po_number, true);
	$criteria->compare('grace_period', $this->grace_period);
	$criteria->compare('expiry_days', $this->expiry_days);

	$criteria->compare('tid_no', $this->tid_no, true);
	$criteria->compare('invoice_number', $this->invoice_number, true);
	$criteria->compare('segment_name', $this->segment_name, true);
	$criteria->compare('po_segment_code', $this->po_segment_code, true);
	$criteria->compare('type_of_asset_name', $this->type_of_asset_name, true);
	$criteria->compare('vehicle_book_expiry_date', $this->vehicle_book_expiry_date, true);
	$criteria->compare('vehicle_book_status', $this->vehicle_book_status, true);
	$criteria->compare('vehicle_book_expired_days', $this->vehicle_book_expired_days);
	$criteria->compare('radioactive_license_expiry_date', $this->radioactive_license_expiry_date, true);
	$criteria->compare('fine', $this->fine);
	$criteria->compare('radioactive_license_status', $this->radioactive_license_status, true);
	$criteria->compare('radioactive_license_expired_days', $this->radioactive_license_expired_days);
	$criteria->compare('asset_status_last_edited_by', $this->asset_status_last_edited_by);
	$criteria->compare('asset_status_last_edited_date', $this->asset_status_last_edited_date, true);
	$criteria->compare('status', $this->status, true);
	$criteria->compare('expiry_date', $this->expiry_date, true);

	if ($invoice_id != null)
	    $criteria->addCondition('invoice_id =' . $invoice_id);
	else
	    $criteria->compare('invoice_id', $this->invoice_id);



	if ($type_of_asset != null)
	    $criteria->compare('type_of_asset_id', $type_of_asset);

	if ($segment != 'Total' && $segment != 'Multi Segment' && $segment != 'Non Segment')
	    $criteria->compare('segment_name', $segment);
	elseif ($segment == 'Multi Segment')
	    $criteria->addCondition("segment_name like '%,%'");
	elseif ($segment == 'Non Segment')
	    $criteria->addCondition("t.segment_name is null");

	if ($status != null) {
	    if ($status != 'Total')
		if ($status == 'Fine' || $status == 'Days Count') {
		    $criteria->compare('status', 'Expired');
		    $criteria->addCondition("asset_status != 'Exported'");
		} else
		if ($status == 'Expired') {
		    $criteria->compare('status', $status);
		    $criteria->addCondition("asset_status != 'Exported'");
		}
		else
		    $criteria->compare('status', $status);
	}

	return $criteria;
    }

    /**
     * Returns the static model of the specified AR class.
     * Please note that you should have this exact method in all your CActiveRecord descendants!
     * @param string $className active record class name.
     * @return VAsset the static model class
     */
    public static function model($className=__CLASS__) {
	return parent::model($className);
    }

    /**
     * Returns primary key for the current view
     *
     * @return String primary key column name
     */
    public function primaryKey() {
	return 'id';
    }

    /**
     * Get the last status of tid
     * @return AssetStatus the last tid status of the tid
     */
    public function getLastStatus() {
	$cr = new CDbCriteria();
	$cr->condition = 'asset_id = ' . $this->id;
	$cr->order = 'created_date desc';
	$cr->limit = 1;
	return AssetStatus::model()->find($cr);
    }

    /**
     * Get number of asset with the specified condition
     * @param String $condition the condition to calculate the number of asset based on it
     * @return Integer the number of asset with the specified condition
     */
    public static function getAssetCount($condition) {
	$result = null;
	if ($condition != null && $condition != '') {
	    $cr = new CDbCriteria();
	    $cr->select = "count(*) as asset_count";
	    $cr->condition = $condition;
	    $vehicle_asset_type = Setting::getVehicleTypeOfAsset();
	    if ($vehicle_asset_type != null && $vehicle_asset_type != '')
		$cr->condition .= ' and type_of_asset_id = ' . $vehicle_asset_type;
	    $model = VAsset::model();
	    $result = $model->commandBuilder->createFindCommand(
			    $model->tableName(), $cr)->queryScalar();
	}
	if ($result == null)
	    $result = 0;
	return $result;
	$result = array();

//	$model = VAssetDashboard::model();
//	$cr = new CDbCriteria();
//	$cr->select = 'count(*) as count,status';
//	$cr->condition = "(status = 'Grace' Or status = 'Expired')";
//	$cr->group = 'status';
//	$vehicle_asset_type = Setting::getVehicleTypeOfAsset();
//	if ($vehicle_asset_type != null && $vehicle_asset_type != '')
//	    $cr->condition .= ' and type_of_asset_id = ' . $vehicle_asset_type;
//
//	$asset_data = $model->commandBuilder->createFindCommand(
//			$model->tableName(), $cr)->queryAll();
//
//	$result['Grace'] = 0;
//	$result['Expired'] = 0;
//
//	if ($asset_data != null)
//	    foreach ($asset_data as $data) {
//		if ($data['status'] == 'Grace')
//		    $result['Grace'] = $data['count'];
//		if ($data['status'] == 'Expired')
//		    $result['Expired'] = $data['count'];
//	    }
//	return $result;
    }

}
